<?php

//
//  Make sure we have sessions setup.
//
session_start();


//
//  Include our common code.
//
include( "actions.inc" );


//
//  Is the user logged in?
//
function loggedIn()
{
   $username = $_SESSION["username"];
   $password = $_SESSION["username"];

   if ( strlen( $password ) && strlen( $username ) )
   {
	return 1;
   }
   else
   {
        return 0;
   }
}


//
//  Handle a login attempt.
//
function handleLogin()
{
   $username = $_POST{'username'};
   $password = $_POST{'password'};
   $port     = $_POST{'port'};
   $host     = $_POST{'hostname'};

   // open a client connection
   $fp = fsockopen ($host, $port, $errno, $errstr);

   // if a handle is not returned
   if (!$fp)
   {
       die("Error: could not open socket connection $host:$port\n");
   }
   else
   {
       // list available machines.
       fputs ($fp, "auth $username $password\n");
	    
       // loop reading until we get either 300 / 400.
       $run = 1;
       while( $run )
       {
          $result = fgets($fp, 100);
          if ( substr($result, 0, 3) == "200" )
	  {
             $run = 1;
	  }
          else if ( substr($result, 0, 3) == "300" )
	  {
             $_SESSION["username"] = $username;
	     $_SESSION["password"] = $password;
             $_SESSION["port"]     = $port;
	     $_SESSION["hostname"] = $host;
	     $run = 0;
	  }
          else if ( substr($result, 0, 3) == "400" )
	  {
	     echo(  substr( $result, 3 ) );
 	     echo( '<p><a href="index.php">Try Again</a></p>' );
  	     $run = 0;
	  }
	}
    }

    fclose( $fp );
}



//
// Show a login form.
//
function showLoginForm()
{
print <<<EOF
<html>
 <head>
  <title>Argo - Login</title>
 </head>
 <body>
 <div style="text-align: center;"><h1>Please Login</h1></div>
 <p>Please login to the Argo system.</p>
 <div style="text-align: center;">
 <form action="index.php" method="post">
 <table>
 <tr><td>Host:</td><td><input type="text" name="hostname" value="localhost" /></td></tr>
 <tr><td>Port:</td><td><input type="text" name="port" value="20203" /></td></tr>
 <tr><td>Username:</td><td><input type="text" name="username" value="admin" /></td></tr>
 <tr><td>Password:</td><td><input type="password" name="password" value="password" /></td></tr>
 <tr><td></td><td><input type="submit" name="login" value="Login"></td></tr>
 </table>
 </form>
 </div>
EOF;
}



//
//  Connect to the Argos server and show all the available hosts.
//

function showHostList()
{
  $host	    = $_SESSION["hostname"];
  $port	    = $_SESSION["port"];
  $password = $_SESSION["password"];
  $username = $_SESSION["username"];

   // open a client connection
   $fp = fsockopen ($host, $port, $errno, $errstr);

   // if a handle is not returned
   if (!$fp)
   {
       die("Error: could not open socket connection $host:$port\n");
   }
   else
   {
       // list available machines.
       fputs ($fp, "auth $username $password\n");
	    
       // loop reading until we get either 300 / 400.
       $run = 1;
       while( $run )
       {
          $result = fgets($fp, 100);
          if ( substr($result, 0, 3) == "300" )
	  {
             $run = 0;
	  }
          else if ( substr($result, 0, 3) == "400" )
	  {
	     echo(  substr( $result, 3 ) );
 	     echo( '<p><a href="index.php">Try Again</a></p>' );
	     exit;
  	     $run = 0;
	  }
	}
 
        // list available machines.
	fputs ($fp, "list available\n");
	    
	// Array to store valid hosts in.
	$Array = array();
	
        // loop reading until we get either 300 / 400.
	$run = 1;
	while( $run )
	{
	   $result = fgets($fp, 100);
           if ( substr($result, 0, 3) == "200" )
           {
		$run = 1;
           }
	   else if ( substr($result, 0, 3) == "300" )
           {
		$run = 0;
	   }
	   else if ( substr($result, 0, 3) == "400" )
	   {
	        $run = 0;
	   }
	   else
	   {
		$Array[]=$result;
	   }
         }

	 echo <<<EOF
<html>
 <head>
  <title>Xen instances upon $host</title>
<script type="text/javascript">
    function toggleMenu(id){
        if(document.getElementById(id).style.display=="none")
            document.getElementById(id).style.display="block";
        else
            document.getElementById(id).style.display="none";
    }
</script>
 </head>
 <body>
 <div style="text-align: center;"><h1>Xen Instances On $host</h1></div>
 
EOF;
	 //
	 // Now we have a list of hostnames in $Array
	 //
	 foreach($Array as $key => $value) 
	 {
	     $value = rtrim($value, "\r\n");
	     echo "<h2><a href=\"info.php?name=$value\">$value</a></h2>\n";
         echo "<p><a onClick=\"toggleMenu('$value')\">Show/Hide</a></p>";
         echo "<div id=\"$value\">\n";
	     echo "<blockquote><pre>";

	     $total = "";

		// list available machines.
		fputs ($fp, "info $value\n");
		// loop reading until we get either 300 / 400.
		$run = 1;
		while( $run )
		  {
		    $result = fgets($fp, 100);
		    if ( substr($result, 0, 3) == "200" )
		      {
			$run = 1;
		      }
		    else if ( substr($result, 0, 3) == "300" )
		      {
			$run = 0;
		      }
		    else if ( substr($result, 0, 3) == "400" )
		      {
			$run = 0;
		      }
		    else
		      {
			$total .=  $result;
		      }
		  }
		
		echo "$total</pre>";

		if ( strpos( $total, "State: Running" ) !== false )
		  {
		    echo ( "<p><a href=\"stop.php?name=$value\">Stop</a> " );
		    echo ( "<a href=\"pause.php?name=$value\">Pause</a></p>" );
		  }
		if ( strpos( $total, "State: Paused" ) !== false )
		  {
		    echo ( "<p><a href=\"stop.php?name=$value\">Stop</a> " );
		    echo ( "<a href=\"unpause.php?name=$value\">Resume</a></p>" );
		  }
		if ( strpos( $total, "State: Off" ) !== false )
		  {
		    echo ( "<p><a href=\"start.php?name=$value\">Start</a></p>" );
		  }
		echo "</blockquote></div><p></p>";

	      }
	echo '<a href="?logout=1">Logout</a></p>';
	    // shut down connection
	    fputs ($fp, "exit\n");
	    fclose ($fp);
	  }
}


  //
  // Decide what to do.
  //
  if ( strlen( $HTTP_POST_VARS{'logout'} ) ||
       strlen( $HTTP_GET_VARS{'logout'} ) )
  {
     session_destroy();
     Header("Location: ./index.php");
  }

  if ( strlen( $HTTP_POST_VARS{'login'} ) )
  {
     handleLogin();

     if ( loggedIn() )
     {
        showHostList( );
     }

  }
  else
  {
     if ( loggedIn() )
     {
        showHostList( );
     }
     else
     {
        showLoginForm();
     }
  }
?>
<hr />
<p align="right"><a href="http://www.steve.org.uk/Software/argo">Argo</a> <? echo( getArgoVersion() ); ?></p>
 </body>
</html>
